Index: history.c
===================================================================
--- history.c	(revision d43edd2156ec9694ba4cec1c13baba690ce46b19)
+++ history.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -15,5 +15,5 @@
 }
 
-char *owl_history_get_prev(owl_history *h)
+const char *owl_history_get_prev(owl_history *h)
 {
 
@@ -32,5 +32,5 @@
 }
 
-char *owl_history_get_next(owl_history *h)
+const char *owl_history_get_next(owl_history *h)
 {
   if (!h) return NULL;
@@ -44,5 +44,5 @@
 }
 
-void owl_history_store(owl_history *h, char *line)
+void owl_history_store(owl_history *h, const char *line)
 {
   int size;
Index: keybinding.c
===================================================================
--- keybinding.c	(revision d43edd2156ec9694ba4cec1c13baba690ce46b19)
+++ keybinding.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -12,5 +12,5 @@
 
 /* sets up a new keybinding for a command */
-int owl_keybinding_init(owl_keybinding *kb, char *keyseq, char *command, void (*function_fn)(void), char *desc)
+int owl_keybinding_init(owl_keybinding *kb, const char *keyseq, const char *command, void (*function_fn)(void), const char *desc)
 {
   char **ktokens;
@@ -100,5 +100,5 @@
 }
 
-char *owl_keybinding_get_desc(owl_keybinding *kb)
+const char *owl_keybinding_get_desc(owl_keybinding *kb)
 {
   return kb->desc;
Index: keymap.c
===================================================================
--- keymap.c	(revision 4d86e066c8f1fe00bd18a85523b809ba4c968947)
+++ keymap.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -3,5 +3,5 @@
 
 /* returns 0 on success */
-int owl_keymap_init(owl_keymap *km, char *name, char *desc, void (*default_fn)(owl_input), void (*prealways_fn)(owl_input), void (*postalways_fn)(owl_input))
+int owl_keymap_init(owl_keymap *km, const char *name, const char *desc, void (*default_fn)(owl_input), void (*prealways_fn)(owl_input), void (*postalways_fn)(owl_input))
 {
   if (!name || !desc) return(-1);
@@ -30,5 +30,5 @@
 
 /* creates and adds a key binding */
-int owl_keymap_create_binding(owl_keymap *km, char *keyseq, char *command, void (*function_fn)(void), char *desc)
+int owl_keymap_create_binding(owl_keymap *km, const char *keyseq, const char *command, void (*function_fn)(void), const char *desc)
 {
   owl_keybinding *kb, *curkb;
@@ -103,5 +103,5 @@
     char buff[100];
     owl_cmd *cmd;
-    char *tmpdesc, *desc = "";
+    const char *tmpdesc, *desc = "";
 
     kb = owl_list_get_element(&km->bindings, i);
@@ -149,5 +149,5 @@
 }
 
-owl_keymap *owl_keyhandler_create_and_add_keymap(owl_keyhandler *kh, char *name, char *desc, void (*default_fn)(owl_input), void (*prealways_fn)(owl_input), void (*postalways_fn)(owl_input))
+owl_keymap *owl_keyhandler_create_and_add_keymap(owl_keyhandler *kh, const char *name, const char *desc, void (*default_fn)(owl_input), void (*prealways_fn)(owl_input), void (*postalways_fn)(owl_input))
 {
   owl_keymap *km;
@@ -167,5 +167,5 @@
 }
 
-owl_keymap *owl_keyhandler_get_keymap(owl_keyhandler *kh, char *mapname)
+owl_keymap *owl_keyhandler_get_keymap(owl_keyhandler *kh, const char *mapname)
 {
   return owl_dict_find_element(&kh->keymaps, mapname);
@@ -187,5 +187,5 @@
 /* sets the active keymap, which will also reset any key state.
  * returns the new keymap, or NULL on failure. */
-owl_keymap *owl_keyhandler_activate(owl_keyhandler *kh, char *mapname)
+owl_keymap *owl_keyhandler_activate(owl_keyhandler *kh, const char *mapname)
 {
   owl_keymap *km;
Index: keypress.c
===================================================================
--- keypress.c	(revision 6551eaecc79df626b1b4f16944d1b477caa4db00)
+++ keypress.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -5,5 +5,5 @@
 static struct _owl_keypress_specialmap {
   int   kj;
-  char *ks;
+  const char *ks;
 } specialmap[] = {
 #ifdef KEY_CODE_YES
@@ -175,5 +175,5 @@
 
 /* returns ERR on failure, else a keycode */
-int owl_keypress_fromstring(char *kb)
+int owl_keypress_fromstring(const char *kb)
 {
   struct _owl_keypress_specialmap *sm;
Index: logging.c
===================================================================
--- logging.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
+++ logging.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -105,5 +105,5 @@
 }
 
-void owl_log_append(owl_message *m, char *filename) {
+void owl_log_append(owl_message *m, const char *filename) {
     FILE *file;
     file=fopen(filename, "a");
@@ -171,5 +171,5 @@
 
 
-void owl_log_outgoing_zephyr_error(char *to, char *text)
+void owl_log_outgoing_zephyr_error(const char *to, const char *text)
 {
   FILE *file;
@@ -230,5 +230,5 @@
 {
   char filename[MAXPATHLEN], allfilename[MAXPATHLEN], *logpath;
-  char *from=NULL;
+  const char *from=NULL;
   char *frombuff=NULL;
   int len, ch, i, personal;
@@ -243,5 +243,5 @@
   } else if (owl_message_is_type_jabber(m)) {
     /* This needs to be fixed to handle groupchat */
-    char* msgtype = owl_message_get_attribute_value(m,"jtype");
+    const char* msgtype = owl_message_get_attribute_value(m,"jtype");
     if (msgtype && !strcmp(msgtype,"groupchat")) {
       personal = 0;
Index: message.c
===================================================================
--- message.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
+++ message.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -55,5 +55,5 @@
  * name already exists, replace the old value with the new value
  */
-void owl_message_set_attribute(owl_message *m, char *attrname, const char *attrvalue)
+void owl_message_set_attribute(owl_message *m, const char *attrname, const char *attrvalue)
 {
   int i, j;
@@ -82,5 +82,5 @@
  * the attribute does not exist
  */
-char *owl_message_get_attribute_value(owl_message *m, char *attrname)
+const char *owl_message_get_attribute_value(owl_message *m, const char *attrname)
 {
   int i, j;
@@ -159,12 +159,12 @@
 }
 
-void owl_message_set_class(owl_message *m, char *class)
+void owl_message_set_class(owl_message *m, const char *class)
 {
   owl_message_set_attribute(m, "class", class);
 }
 
-char *owl_message_get_class(owl_message *m)
-{
-  char *class;
+const char *owl_message_get_class(owl_message *m)
+{
+  const char *class;
 
   class=owl_message_get_attribute_value(m, "class");
@@ -173,12 +173,12 @@
 }
 
-void owl_message_set_instance(owl_message *m, char *inst)
+void owl_message_set_instance(owl_message *m, const char *inst)
 {
   owl_message_set_attribute(m, "instance", inst);
 }
 
-char *owl_message_get_instance(owl_message *m)
-{
-  char *instance;
+const char *owl_message_get_instance(owl_message *m)
+{
+  const char *instance;
 
   instance=owl_message_get_attribute_value(m, "instance");
@@ -187,12 +187,12 @@
 }
 
-void owl_message_set_sender(owl_message *m, char *sender)
+void owl_message_set_sender(owl_message *m, const char *sender)
 {
   owl_message_set_attribute(m, "sender", sender);
 }
 
-char *owl_message_get_sender(owl_message *m)
-{
-  char *sender;
+const char *owl_message_get_sender(owl_message *m)
+{
+  const char *sender;
 
   sender=owl_message_get_attribute_value(m, "sender");
@@ -201,12 +201,12 @@
 }
 
-void owl_message_set_zsig(owl_message *m, char *zsig)
+void owl_message_set_zsig(owl_message *m, const char *zsig)
 {
   owl_message_set_attribute(m, "zsig", zsig);
 }
 
-char *owl_message_get_zsig(owl_message *m)
-{
-  char *zsig;
+const char *owl_message_get_zsig(owl_message *m)
+{
+  const char *zsig;
 
   zsig=owl_message_get_attribute_value(m, "zsig");
@@ -215,14 +215,14 @@
 }
 
-void owl_message_set_recipient(owl_message *m, char *recip)
+void owl_message_set_recipient(owl_message *m, const char *recip)
 {
   owl_message_set_attribute(m, "recipient", recip);
 }
 
-char *owl_message_get_recipient(owl_message *m)
+const char *owl_message_get_recipient(owl_message *m)
 {
   /* this is stupid for outgoing messages, we need to fix it. */
 
-  char *recip;
+  const char *recip;
 
   recip=owl_message_get_attribute_value(m, "recipient");
@@ -236,7 +236,7 @@
 }
 
-char *owl_message_get_realm(owl_message *m)
-{
-  char *realm;
+const char *owl_message_get_realm(owl_message *m)
+{
+  const char *realm;
   
   realm=owl_message_get_attribute_value(m, "realm");
@@ -245,12 +245,12 @@
 }
 
-void owl_message_set_body(owl_message *m, char *body)
+void owl_message_set_body(owl_message *m, const char *body)
 {
   owl_message_set_attribute(m, "body", body);
 }
 
-char *owl_message_get_body(owl_message *m)
-{
-  char *body;
+const char *owl_message_get_body(owl_message *m)
+{
+  const char *body;
 
   body=owl_message_get_attribute_value(m, "body");
@@ -260,12 +260,12 @@
 
 
-void owl_message_set_opcode(owl_message *m, char *opcode)
+void owl_message_set_opcode(owl_message *m, const char *opcode)
 {
   owl_message_set_attribute(m, "opcode", opcode);
 }
 
-char *owl_message_get_opcode(owl_message *m)
-{
-  char *opcode;
+const char *owl_message_get_opcode(owl_message *m)
+{
+  const char *opcode;
 
   opcode=owl_message_get_attribute_value(m, "opcode");
@@ -288,5 +288,5 @@
 int owl_message_is_loginout(owl_message *m)
 {
-  char *res;
+  const char *res;
 
   res=owl_message_get_attribute_value(m, "loginout");
@@ -297,5 +297,5 @@
 int owl_message_is_login(owl_message *m)
 {
-  char *res;
+  const char *res;
 
   res=owl_message_get_attribute_value(m, "loginout");
@@ -308,5 +308,5 @@
 int owl_message_is_logout(owl_message *m)
 {
-  char *res;
+  const char *res;
 
   res=owl_message_get_attribute_value(m, "loginout");
@@ -323,5 +323,5 @@
 int owl_message_is_private(owl_message *m)
 {
-  char *res;
+  const char *res;
 
   res=owl_message_get_attribute_value(m, "isprivate");
@@ -330,5 +330,5 @@
 }
 
-char *owl_message_get_timestr(owl_message *m)
+const char *owl_message_get_timestr(owl_message *m)
 {
   if (m->timestr) return(m->timestr);
@@ -356,11 +356,11 @@
 }
 
-void owl_message_set_type(owl_message *m, char* type)
+void owl_message_set_type(owl_message *m, const char* type)
 {
   owl_message_set_attribute(m, "type", type);
 }
 
-int owl_message_is_type(owl_message *m, char *type) {
-  char * t = owl_message_get_attribute_value(m, "type");
+int owl_message_is_type(owl_message *m, const char *type) {
+  const char * t = owl_message_get_attribute_value(m, "type");
   if(!t) return 0;
   return !strcasecmp(t, type);
@@ -399,5 +399,5 @@
 }
 
-char *owl_message_get_text(owl_message *m)
+const char *owl_message_get_text(owl_message *m)
 {
   owl_message_format(m);
@@ -462,12 +462,12 @@
 }
 
-char *owl_message_get_zwriteline(owl_message *m)
-{
-  char *z = owl_message_get_attribute_value(m, "zwriteline");
+const char *owl_message_get_zwriteline(owl_message *m)
+{
+  const char *z = owl_message_get_attribute_value(m, "zwriteline");
   if (!z) return "";
   return z;
 }
 
-void owl_message_set_zwriteline(owl_message *m, char *line)
+void owl_message_set_zwriteline(owl_message *m, const char *line)
 {
   owl_message_set_attribute(m, "zwriteline", line);
@@ -493,10 +493,10 @@
 #endif
 
-void owl_message_set_hostname(owl_message *m, char *hostname)
+void owl_message_set_hostname(owl_message *m, const char *hostname)
 {
   m->hostname=owl_global_intern(&g, hostname);
 }
 
-char *owl_message_get_hostname(owl_message *m)
+const char *owl_message_get_hostname(owl_message *m)
 {
   return(m->hostname);
@@ -542,5 +542,5 @@
 
 int owl_message_is_answered(owl_message *m) {
-  char *q;
+  const char *q;
   if(!owl_message_is_question(m)) return 0;
   q = owl_message_get_attribute_value(m, "question");
@@ -568,5 +568,5 @@
 char *owl_message_get_cc(owl_message *m)
 {
-  char *cur;
+  const char *cur;
   char *out, *end;
 
@@ -586,5 +586,5 @@
 {
   char *cc, *out, *end, *shortuser, *recip;
-  char *user;
+  const char *user;
 
   cc = owl_message_get_cc(m);
@@ -625,6 +625,6 @@
 }
 
-char *owl_message_get_type(owl_message *m) {
-  char * type = owl_message_get_attribute_value(m, "type");
+const char *owl_message_get_type(owl_message *m) {
+  const char * type = owl_message_get_attribute_value(m, "type");
   if(!type) {
     return "generic";
@@ -633,5 +633,5 @@
 }
 
-char *owl_message_get_direction(owl_message *m) {
+const char *owl_message_get_direction(owl_message *m) {
   switch (m->direction) {
   case OWL_MESSAGE_DIRECTION_IN:
@@ -646,5 +646,5 @@
 }
 
-int owl_message_parse_direction(char *d) {
+int owl_message_parse_direction(const char *d) {
   if(!strcmp(d, "in")) {
     return OWL_MESSAGE_DIRECTION_IN;
@@ -657,5 +657,5 @@
 
 
-char *owl_message_get_login(owl_message *m) {
+const char *owl_message_get_login(owl_message *m) {
   if (owl_message_is_login(m)) {
     return "login";
@@ -668,5 +668,5 @@
 
 
-char *owl_message_get_header(owl_message *m) {
+const char *owl_message_get_header(owl_message *m) {
   return owl_message_get_attribute_value(m, "adminheader");
 }
@@ -688,5 +688,5 @@
  *                 1 it's a login message
  */
-void owl_message_create_aim(owl_message *m, char *sender, char *recipient, char *text, int direction, int loginout)
+void owl_message_create_aim(owl_message *m, const char *sender, const char *recipient, const char *text, int direction, int loginout)
 {
   owl_message_init(m);
@@ -714,5 +714,5 @@
 }
 
-void owl_message_create_admin(owl_message *m, char *header, char *text)
+void owl_message_create_admin(owl_message *m, const char *header, const char *text)
 {
   owl_message_init(m);
@@ -723,5 +723,5 @@
 
 /* caller should set the direction */
-void owl_message_create_loopback(owl_message *m, char *text)
+void owl_message_create_loopback(owl_message *m, const char *text)
 {
   owl_message_init(m);
@@ -737,5 +737,5 @@
 {
   struct hostent *hent;
-  char *ptr;
+  const char *ptr;
   char *tmp, *tmp2;
   int len;
@@ -852,8 +852,8 @@
 
 /* If 'direction' is '0' it is a login message, '1' is a logout message. */
-void owl_message_create_pseudo_zlogin(owl_message *m, int direction, char *user, char *host, char *time, char *tty)
+void owl_message_create_pseudo_zlogin(owl_message *m, int direction, const char *user, const char *host, const char *time, const char *tty)
 {
   char *longuser;
-  char *ptr;
+  const char *ptr;
 
 #ifdef HAVE_LIBZEPHYR
@@ -898,5 +898,5 @@
 }
 
-void owl_message_create_from_zwriteline(owl_message *m, char *line, char *body, char *zsig)
+void owl_message_create_from_zwriteline(owl_message *m, const char *line, const char *body, const char *zsig)
 {
   owl_zwrite z;
Index: obarray.c
===================================================================
--- obarray.c	(revision fa4562c3dde208105e6938363d047e5622012e67)
+++ obarray.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -14,8 +14,8 @@
  * the index it should be inserted at.
  */
-int owl_obarray_lookup(owl_obarray *oa, char * key, char ** val) /*noproto*/
+int owl_obarray_lookup(owl_obarray *oa, const char * key, const char ** val) /*noproto*/
 {
   int first, last, mid;
-  char * str;
+  const char * str;
   int cmp;
 
@@ -41,7 +41,7 @@
 
 /* Returns NULL if the string doesn't exist in the obarray */
-char * owl_obarray_find(owl_obarray *oa, char * string)
+const char * owl_obarray_find(owl_obarray *oa, const char * string)
 {
-  char *v;
+  const char *v;
   owl_obarray_lookup(oa, string, &v);
   return v;
@@ -49,7 +49,7 @@
 
 /* Inserts the string into the obarray if it doesn't exist */
-char * owl_obarray_insert(owl_obarray *oa, char * string)
+const char * owl_obarray_insert(owl_obarray *oa, const char * string)
 {
-  char *v;
+  const char *v;
   int i;
   i = owl_obarray_lookup(oa, string, &v);
@@ -77,5 +77,5 @@
 int owl_obarray_regtest(void) {
   int numfailed = 0;
-  char *p,*p2;
+  const char *p,*p2;
 
   owl_obarray oa;
Index: owl.c
===================================================================
--- owl.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
+++ owl.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -44,12 +44,12 @@
   int newmsgs, nexttimediff;
   struct sigaction sigact;
-  char *configfile, *tty, **argvsave;
+  const char *configfile, *tty, *const *argvsave;
   char *perlout, *perlerr;
-  char *confdir;
+  const char *confdir;
   owl_filter *f;
   owl_style *s;
   time_t nexttime, now;
   struct tm *today;
-  char *dir;
+  const char *dir;
   struct termios tio;
   owl_message *m;
Index: owl.h
===================================================================
--- owl.h	(revision c529ac8bb1d8b29ebbfc9c8c4d856b1a5fa687a8)
+++ owl.h	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -202,9 +202,9 @@
 #endif
 
-/* Convert char ** into char **.  This conversion is safe,
+/* Convert char *const * into const char *const *.  This conversion is safe,
  * and implicit in C++ (conv.qual 4) but for some reason not in C. */
-static inline char **strs(char **pstr)
+static inline const char *const *strs(char *const *pstr)
 {
-  return (char **)pstr;
+  return (const char *const *)pstr;
 }
 
@@ -218,7 +218,7 @@
   char *description;		/* detailed description */
   void *val;                    /* current value */
-  int  (*validate_fn)(struct _owl_variable *v, void *newval);
+  int  (*validate_fn)(struct _owl_variable *v, const void *newval);
                                 /* returns 1 if newval is valid */
-  int  (*set_fn)(struct _owl_variable *v, void *newval); 
+  int  (*set_fn)(struct _owl_variable *v, const void *newval); 
                                 /* sets the variable to a value
 				 * of the appropriate type.
@@ -226,5 +226,5 @@
 				 * should make a copy. 
 				 * returns 0 on success. */
-  int  (*set_fromstring_fn)(struct _owl_variable *v, char *newval);
+  int  (*set_fromstring_fn)(struct _owl_variable *v, const char *newval);
                                 /* sets the variable to a value
 				 * of the appropriate type.
@@ -232,10 +232,10 @@
 				 * should make a copy. 
 				 * returns 0 on success. */
-  void *(*get_fn)(struct _owl_variable *v);
+  const void *(*get_fn)(struct _owl_variable *v);
 				/* returns a reference to the current value.
 				 * WARNING:  this approach is hard to make
 				 * thread-safe... */
   int  (*get_tostring_fn)(struct _owl_variable *v, 
-			  char *buf, int bufsize, void *val); 
+			  char *buf, int bufsize, const void *val); 
                                 /* converts val to a string 
 				 * and puts into buf */
@@ -299,5 +299,5 @@
   
   /* These don't take any context */
-  char *(*cmd_args_fn)(int argc, char **argv, char *buff);  
+  char *(*cmd_args_fn)(int argc, const char *const *argv, const char *buff);  
 				/* takes argv and the full command as buff.
 				 * caller must free return value if !NULL */
@@ -306,5 +306,5 @@
 
   /* The following also take the active context if it's valid */
-  char *(*cmd_ctxargs_fn)(void *ctx, int argc, char **argv, char *buff);  
+  char *(*cmd_ctxargs_fn)(void *ctx, int argc, const char *const *argv, const char *buff);  
 				/* takes argv and the full command as buff.
 				 * caller must free return value if !NULL */
@@ -328,5 +328,5 @@
 
 typedef struct _owl_pair {
-  char *key;
+  const char *key;
   char *value;
 } owl_pair;
@@ -342,5 +342,5 @@
   struct _owl_fmtext_cache * fmtext;
   int delete;
-  char *hostname;
+  const char *hostname;
   owl_list attributes;            /* this is a list of pairs */
   char *timestr;
Index: pair.c
===================================================================
--- pair.c	(revision de1c8a59c19d33ab73607ff6539f55d51088ec6b)
+++ pair.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -1,10 +1,10 @@
 #include "owl.h"
 
-void owl_pair_create(owl_pair *p, char *key, char *value) {
+void owl_pair_create(owl_pair *p, const char *key, char *value) {
   p->key=key;
   p->value=value;
 }
 
-void owl_pair_set_key(owl_pair *p, char *key) {
+void owl_pair_set_key(owl_pair *p, const char *key) {
   p->key=key;
 }
@@ -14,5 +14,5 @@
 }
 
-char *owl_pair_get_key(owl_pair *p) {
+const char *owl_pair_get_key(owl_pair *p) {
   return(p->key);
 }
Index: perlconfig.c
===================================================================
--- perlconfig.c	(revision fa4562c3dde208105e6938363d047e5622012e67)
+++ perlconfig.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -14,5 +14,5 @@
 static void owl_perl_xs_init(pTHX)
 {
-  char *file = __FILE__;
+  const char *file = __FILE__;
   dXSUB_SYS;
   {
@@ -26,5 +26,5 @@
   HV *h, *stash;
   SV *hr;
-  char *type;
+  const char *type;
   char *ptr, *utype, *blessas;
   int i, j;
@@ -135,5 +135,5 @@
   HE * ent;
   I32 count, len;
-  char *key,*val;
+  const char *key,*val;
   HV * hash;
   struct tm tm;
@@ -197,5 +197,5 @@
 /* Calls in a scalar context, passing it a hash reference.
    If return value is non-null, caller must free. */
-char *owl_perlconfig_call_with_message(char *subname, owl_message *m)
+char *owl_perlconfig_call_with_message(const char *subname, owl_message *m)
 {
   dSP ;
@@ -246,5 +246,5 @@
    If the return value is non-null, the caller must free it.
  */
-char * owl_perlconfig_message_call_method(owl_message *m, char *method, int argc, char ** argv)
+char * owl_perlconfig_message_call_method(owl_message *m, const char *method, int argc, const char ** argv)
 {
   dSP;
@@ -296,10 +296,10 @@
 
 
-char *owl_perlconfig_initperl(char * file, int *Pargc, char ***Pargv, char *** Penv)
+char *owl_perlconfig_initperl(const char * file, int *Pargc, char ***Pargv, char *** Penv)
 {
   int ret;
   PerlInterpreter *p;
   char *err;
-  char *args[4] = {"", "-e", "0;", NULL};
+  const char *args[4] = {"", "-e", "0;", NULL};
   AV *inc;
   char *path;
@@ -372,5 +372,5 @@
 
 /* returns whether or not a function exists */
-int owl_perlconfig_is_function(char *fn) {
+int owl_perlconfig_is_function(const char *fn) {
   if (get_cv(fn, FALSE)) return(1);
   else return(0);
@@ -378,9 +378,9 @@
 
 /* caller is responsible for freeing returned string */
-char *owl_perlconfig_execute(char *line)
+char *owl_perlconfig_execute(const char *line)
 {
   STRLEN len;
   SV *response;
-  char *preout;
+  const char *preout;
   char *out;
 
@@ -408,5 +408,5 @@
 }
 
-void owl_perlconfig_getmsg(owl_message *m, char *subname)
+void owl_perlconfig_getmsg(owl_message *m, const char *subname)
 {
   char *ptr = NULL;
@@ -419,5 +419,5 @@
 
 /* Called on all new messages; receivemsg is only called on incoming ones */
-void owl_perlconfig_newmsg(owl_message *m, char *subname)
+void owl_perlconfig_newmsg(owl_message *m, const char *subname)
 {
   char *ptr = NULL;
@@ -429,5 +429,5 @@
 }
 
-void owl_perlconfig_new_command(char *name)
+void owl_perlconfig_new_command(const char *name)
 {
   dSP;
@@ -452,5 +452,5 @@
 }
 
-char *owl_perlconfig_perlcmd(owl_cmd *cmd, int argc, char **argv)
+char *owl_perlconfig_perlcmd(owl_cmd *cmd, int argc, const char *const *argv)
 {
   int i, count;
Index: perlglue.xs
===================================================================
--- perlglue.xs	(revision 3ff3d860fb7ff24e9de46e161c8260f764bc762c)
+++ perlglue.xs	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -32,8 +32,8 @@
 char *
 command(cmd, ...)
-	char *cmd
+	const char *cmd
 	PREINIT:
 		char *rv = NULL;
-		char **argv;
+		const char **argv;
 		int i;
 	CODE:
@@ -85,5 +85,5 @@
 		RETVAL
 
-char *
+const char *
 zephyr_getsender()
 	CODE:
@@ -94,6 +94,6 @@
 void
 zephyr_zwrite(cmd,msg)
-	char *cmd
-	char *msg
+	const char *cmd
+	const char *msg
 	PREINIT:
 		int i;
@@ -103,5 +103,5 @@
 char *
 ztext_stylestrip(ztext)
-	char *ztext
+	const char *ztext
 	PREINIT:
 		char *rv = NULL;
@@ -116,5 +116,5 @@
 char *
 zephyr_smartstrip_user(in)
-	char *in
+	const char *in
 	PREINIT:
 		char *rv = NULL;
@@ -157,6 +157,6 @@
 
 void admin_message(header, body) 
-	char *header
-	char *body
+	const char *header
+	const char *body
 	CODE:
 	{
@@ -165,5 +165,5 @@
 
 void start_question(line, callback)
-	char *line
+	const char *line
 	SV *callback
 	PREINIT:
@@ -181,5 +181,5 @@
 
 void start_password(line, callback)
-	char *line
+	const char *line
 	SV *callback
 	PREINIT:
@@ -197,5 +197,5 @@
 
 void start_edit_win(line, callback)
-	char *line
+	const char *line
 	SV *callback
 	PREINIT:
@@ -223,5 +223,5 @@
 
 
-char * 
+const char * 
 get_data_dir ()
 	CODE:
@@ -230,5 +230,5 @@
 	RETVAL
 
-char * 
+const char * 
 get_config_dir ()
 	CODE:
@@ -239,5 +239,5 @@
 void
 popless_text(text) 
-	char *text
+	const char *text
 	CODE:
 	{
@@ -247,5 +247,5 @@
 void
 popless_ztext(text) 
-	char *text
+	const char *text
 	CODE:
 	{
@@ -259,5 +259,5 @@
 void
 error(text) 
-	char *text
+	const char *text
 	CODE:
 	{
@@ -267,5 +267,5 @@
 void
 debug(text)
-	char *text
+	const char *text
 	CODE:
 	{
@@ -275,5 +275,5 @@
 void
 message(text)
-	char *text
+	const char *text
 	CODE:
 	{
@@ -283,5 +283,5 @@
 void
 create_style(name, object)
-     char *name
+     const char *name
      SV  *object
      PREINIT:
@@ -303,5 +303,5 @@
 void
 _remove_filter(filterName)
-	char *filterName
+	const char *filterName
 	CODE:
 	{
@@ -315,5 +315,5 @@
 char *
 wordwrap(in, cols)
-	char *in
+	const char *in
 	int cols
 	PREINIT:
@@ -368,5 +368,5 @@
 		AV *styles;
 		owl_list l;
-		char *name;
+		const char *name;
 		int i;
 	CODE:
@@ -393,5 +393,5 @@
 		AV *vars;
 		owl_list l;
-		char *name;
+		const char *name;
 		int i;
 	CODE:
@@ -448,8 +448,8 @@
 void
 new_variable_string(name, ival, summ, desc)
-	char * name
-	char * ival
-	char * summ
-	char * desc
+	const char * name
+	const char * ival
+	const char * summ
+	const char * desc
 	CODE:
 	owl_variable_dict_newvar_string(owl_global_get_vardict(&g),
@@ -461,8 +461,8 @@
 void
 new_variable_int(name, ival, summ, desc)
-	char * name
+	const char * name
 	int ival
-	char * summ
-	char * desc
+	const char * summ
+	const char * desc
 	CODE:
 	owl_variable_dict_newvar_int(owl_global_get_vardict(&g),
@@ -474,8 +474,8 @@
 void
 new_variable_bool(name, ival, summ, desc)
-	char * name
+	const char * name
 	int ival
-	char * summ
-	char * desc
+	const char * summ
+	const char * desc
 	CODE:
 	owl_variable_dict_newvar_bool(owl_global_get_vardict(&g),
@@ -520,5 +520,5 @@
 replace(count, string)
 	int count;
-	char *string;
+	const char *string;
 	CODE:
 		RETVAL = owl_editwin_replace(owl_global_get_typwin(&g), count, string);
@@ -536,5 +536,5 @@
 int
 replace_region(string)
-	char *string;
+	const char *string;
 	CODE:
 		RETVAL = owl_editwin_replace_region(owl_global_get_typwin(&g), string);
Index: popexec.c
===================================================================
--- popexec.c	(revision 7565f8f631fb7f476cf9f985819955cb23a1b721)
+++ popexec.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -9,5 +9,5 @@
 
 /* starts up popexec in a new viewwin */
-owl_popexec *owl_popexec_new(char *command)
+owl_popexec *owl_popexec_new(const char *command)
 {
   owl_popexec *pe;
Index: regex.c
===================================================================
--- regex.c	(revision 41c9a9675faf455c3c6adfbc629faf55ddbfe10f)
+++ regex.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -8,9 +8,9 @@
 }
 
-int owl_regex_create(owl_regex *re, char *string)
+int owl_regex_create(owl_regex *re, const char *string)
 {
   int ret;
   char buff1[LINE];
-  char *ptr;
+  const char *ptr;
   
   re->string=owl_strdup(string);
@@ -36,5 +36,5 @@
 }
 
-int owl_regex_create_quoted(owl_regex *re, char *string)
+int owl_regex_create_quoted(owl_regex *re, const char *string)
 {
   char *quoted;
@@ -46,5 +46,5 @@
 }
 
-int owl_regex_compare(owl_regex *re, char *string, int *start, int *end)
+int owl_regex_compare(owl_regex *re, const char *string, int *start, int *end)
 {
   int out, ret;
@@ -74,5 +74,5 @@
 }
 
-char *owl_regex_get_string(owl_regex *re)
+const char *owl_regex_get_string(owl_regex *re)
 {
   return(re->string);
Index: stubgen.pl
===================================================================
--- stubgen.pl	(revision 1aee7d914de75510e7cf09c452bad63b2dad2166)
+++ stubgen.pl	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -28,7 +28,7 @@
 	print "  return owl_variable_get_bool(&g->vars, \"$varname\");\n}\n";
     } elsif ($vartype =~ /^PATH/ or $vartype =~ /^STRING/) {
-	print "void owl_global_set_$altvarname(owl_global *g, char *text) {\n";
+	print "void owl_global_set_$altvarname(owl_global *g, const char *text) {\n";
 	print "  owl_variable_set_string(&g->vars, \"$varname\", text);\n}\n";
-	print "char *owl_global_get_$altvarname(owl_global *g) {\n";
+	print "const char *owl_global_get_$altvarname(owl_global *g) {\n";
 	print "  return owl_variable_get_string(&g->vars, \"$varname\");\n}\n";
     } elsif ($vartype =~ /^INT/ or $vartype =~ /^ENUM/) {
Index: style.c
===================================================================
--- style.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
+++ style.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -2,5 +2,5 @@
 #include "owl.h"
 
-void owl_style_create_perl(owl_style *s, char *name, SV *obj)
+void owl_style_create_perl(owl_style *s, const char *name, SV *obj)
 {
   s->name=owl_strdup(name);
@@ -8,5 +8,5 @@
 }
 
-int owl_style_matches_name(owl_style *s, char *name)
+int owl_style_matches_name(owl_style *s, const char *name)
 {
   if (!strcmp(s->name, name)) return(1);
@@ -14,10 +14,10 @@
 }
 
-char *owl_style_get_name(owl_style *s)
+const char *owl_style_get_name(owl_style *s)
 {
   return(s->name);
 }
 
-char *owl_style_get_description(owl_style *s)
+const char *owl_style_get_description(owl_style *s)
 {
   SV *sv = NULL;
@@ -41,5 +41,5 @@
 void owl_style_get_formattext(owl_style *s, owl_fmtext *fm, owl_message *m)
 {
-  char *body;
+  const char *body;
   char *indent;
   int curlen;
Index: text.c
===================================================================
--- text.c	(revision 65b21736092356a35d24e53dc2e6b92e13174131)
+++ text.c	(revision e19eb97bacd75cf02905ec2b7a6a73b9642b907a)
@@ -5,7 +5,7 @@
 #include "owl.h"
 
-void owl_text_indent(char *out, char *in, int n)
-{
-  char *ptr1, *ptr2, *last;
+void owl_text_indent(char *out, const char *in, int n)
+{
+  const char *ptr1, *ptr2, *last;
   int i;
 
@@ -29,5 +29,5 @@
 }
 
-int owl_text_num_lines(char *in)
+int owl_text_num_lines(const char *in)
 {
   int lines, i;
@@ -46,7 +46,7 @@
 
 /* caller must free the return */
-char *owl_text_htmlstrip(char *in)
-{
-  char *ptr1, *end, *ptr2, *ptr3;
+char *owl_text_htmlstrip(const char *in)
+{
+  const char *ptr1, *end, *ptr2, *ptr3;
   char *out, *out2;
 
@@ -129,8 +129,8 @@
 
 /* Caller must free return */
-char *owl_text_expand_tabs(char *in)
+char *owl_text_expand_tabs(const char *in)
 {
   int ntabs = 0;
-  char *p = in;
+  const char *p = in;
   char *ret, *out;
   int col;
@@ -166,5 +166,5 @@
 
 /* caller must free the return */
-char *owl_text_wordwrap(char *in, int col)
+char *owl_text_wordwrap(const char *in, int col)
 {
   char *out;
@@ -227,8 +227,8 @@
 
 /* return 1 if a string is only whitespace, otherwise 0 */
-int only_whitespace(char *s)
+int only_whitespace(const char *s)
 {
   if (g_utf8_validate(s,-1,NULL)) {
-    char *p;
+    const char *p;
     for(p = s; p[0]; p=g_utf8_next_char(p)) {
       if (!g_unichar_isspace(g_utf8_get_char(p))) return 0;
@@ -244,5 +244,5 @@
 }
 
-char *owl_getquoting(char *line)
+const char *owl_getquoting(const char *line)
 {
   if (line[0]=='\0') return("'");
@@ -257,5 +257,5 @@
  * Caller must free returned string.
  */
-char *owl_text_substitute(char *in, char *from, char *to)
+char *owl_text_substitute(const char *in, const char *from, const char *to)
 {
   
@@ -307,5 +307,5 @@
  * On success returns the string, on error returns NULL.
  */
-char *owl_text_quote(char *in, char *toquote, char *quotestr)
+char *owl_text_quote(const char *in, const char *toquote, const char *quotestr)
 {
   int i, x, r, place, escape;
